FSCK(8)

NAME
fsck - check and repair a Linux file system

SYNOPSIS
fsck [ -AVRTNP ] [ -s ] [ -t fstype ] [ fs-options ] filesys [ ... ]

DESCRIPTION
fsck is used to check and optionally repair a Linux file system. filesys is either the device name (e.g. /dev/hda1, /dev/sdb2) or the mount point (e.g. /, /usr, /home) for the file system. If this invocation of fsck has several filesystems on different physical disk drives to check, then fsck will try to run them in parallel. This reduces the total amount time it takes to check all of the filesystems, since fsck takes advantage of the parallelism of multiple disk spindles.

The exit code returned by fsck is the sum of the following conditions:
    0    - No errors
    1    - File system errors corrected
    2    - System should be rebooted
    4    - File system errors left uncorrected
    8    - Operational error
    16    - Usage or syntax error
    128    - Shared library error
The exit code returned when all file systems are checked using the -A option is the bit-wise OR of the exit codes for each file system that is checked.

In actuality, fsck is simply a front-end for the various file system checkers (fsck.fstype) available under Linux. The file system-specific checker is searched for in /sbin first, then in /etc/fs and /etc, and finally in the directories listed in the PATH environment variable. Please see the file system-specific checker manual pages for further details.

OPTIONS

-A  Walk through the /etc/fstab file and try to check all file systems in one run. This option is typically used from the /etc/rc system initalization file, instead of multiple commands for checking a single file system.

-R  When checking all file systems with the -A flag, skip the root file system (in case it's already mounted read-write).

-T  Don't show the title on startup.

-N  Don't execute, just show what would be done.

-P  When the -A flag is set, check the root filesystem in parallel with the other filesystems. This is not the safest thing in the world to do, since if the root filesystem is in doubt things like the e2fsck(8) executable might be corrupted! This option is mainly provided for those sysadmins who don't want to repartition the root filesystem to be small and compact (which is really the right solution).

-s  Serialize fsck operations. This is a good idea if you checking multiple filesystems and the checkers are in an interactive mode. (Note: e2fsck(8) runs in an interactive mode by default. To make e2fsck(8) run in a non-interactive mode, you must either specify the -p or -a option, if you wish for errors to be corrected automatically, or the -n option if you do not.)

-V  Produce verbose output, including all file system-specific commands that are executed.

-t fstype
    Specifies the type of file system to be checked. When the -A flag is specified, only filesystems that match fstype are checked. If fstype is prefixed with no then only filesystems whose type does not match fstype are checked.

    Normally, the filesystem type is deduced by searching for filesys in the /etc/fstab file and using the corresponding entry. If the type can not be deduced, fsck will use the type specified by the -t option if it specifies a unique filesystem type. If this type is not available, then the default file system type (currently ext2) is used.

fs-options
    Any options which are not understood by fsck, or which follow the -- option are treated as file system-specific options to be passed to the file system-specific checker.

Currently, standardized file system-specific options are somewhat in flux. Although not guaranteed, the following options are supported by most file system checkers:

-a  Automatically repair the file system without any questions (use this option with caution). Note that e2fsck(8) supports -a for backwards compatibility only. This option is mapped to e2fsck's -p option which is safe to use, unlike the -a option that most file system checkers support.

-r  Interactively repair the filesystem (ask for confirmations). Note: It is generally a bad idea to use this option if multiple fsck's are being run in parallel. Also note that this is e2fsck's default behavior; it supports this option for backwards compatibility reasons only.

AUTHOR
Theodore Ts'o (tytso@mit.edu)

The manual page was shamelessly adapted from David Engel and Fred van Kempen's generic fsck front end program, which was in turn shamelessly adapted from Remy Card's version for the ext2 file system.

FILES
/etc/fstab.

SEE ALSO
fstab(5), mkfs(8), fsck.minix(8), fsck.ext2(8) or e2fsck(8), fsck.xiafs(8).